#include "spider.h"
#define TARGETBOX 1 // [1,31] Sets which box the Pokémon is cloned into
#define SOURCEBOX 1 // [1,31] Sets the box where the source Pokémon resides
#define SOURCESLOT 1 // [1,30] Sets the slot where the source Pokémon resides

int (*GX_SetTextureCopy)(void *input_buffer, void *output_buffer, unsigned int size, int in_x, int in_y, int out_x, int out_y, int flags) = 0x0011DD48;
int (*GSPGPU_FlushDataCache)(void *addr, unsigned int len) = 0x00191504;

int uvl_entry ()
{
	unsigned int addr;
	int *buf = 0x18410000;
	int *written = 0x08F01000;
	int i;
    unsigned int slot;
    
    
	unsigned int EBUS;
	unsigned int constblock;
	unsigned int offset;
	int j;
	int ADJ;
	
	addr = 0x17900000; //Way lower than necessary, but we're going to hunt for the relative offsets of box data.
	
	EBUS = 0;
	constblock = 0;
	offset = 0;
	ADJ = 0;
	
	for (j=0; j<0x10 && offset == 0;j++)
	{
		GSPGPU_FlushDataCache(addr, 0x10000);
		GX_SetTextureCopy(addr, buf, 0x10000, 0, 0, 0, 0, 8);
		GSPGPU_FlushDataCache(buf, 0x10000);
		svcSleepThread(0x400000LL);
		for (i = 0; i < 0x4000; i++)
		{
			if ((buf[i] == 0x53554245 && buf[i-1] == 0 && buf[i-2] == 0 && buf[i-3] == 0) && EBUS == 0)
			{
				EBUS = addr+4*i;
			}
			if ((buf[i] == 0x53554245 && buf[i+1] == 0 && buf[i+2] == 0 && buf[i+3] == 0) && EBUS == 0)
			{
				EBUS = addr+4*i;
			}
			if ((buf[i] == 0x00000126) && (buf[i+1] == 0x00000000) && (buf[i+2] == 0x22018230) && (buf[i+3] == 0x09060D30)) //Static data in save files.
			{
				constblock = addr+4*i;
			}
		}
		if (constblock != 0 && EBUS != 0)
		{
			unsigned int diff = constblock-EBUS;
			if (diff == 0x38A0 || diff == 0x383C || diff == 0x3750 || diff == 0x3664 || diff == 0x3608) // ORAS
			{
				offset = constblock+0xFFE8;
				ADJ = 1;
			}
			else if (diff == 0x37DC|| diff == 0x3778 || diff == 0x368C || diff == 0x35A0) //XY
			{
				offset = constblock+0x848;
				ADJ = 2;
			}
			else //wtf
			{
				offset = 0;
				ADJ=0;
			}
		}
		addr += 0x10000;
	}
		
	if (offset != 0)
    {
		addr = offset;
		GSPGPU_FlushDataCache(addr, 0x10000);
		GX_SetTextureCopy(addr, buf, 0x10000, 0, 0, 0, 0, 8);
		GSPGPU_FlushDataCache(buf, 0x10000);
		svcSleepThread(0x400000LL);
		svcSleepThread(0x400000LL);
        
        // Each box contains 30 slots 0x3A words long each
        // Game contains 31 boxes 0x6CC words long each
        for (slot = 0; slot < 0x6CC; slot += 0x3A) // Clone into every slot in the box
		{
            for (i = 0; i < 0x3A; i++)
            {
			    buf[i+ADJ+slot+(TARGETBOX-1)*0x6CC] = buf[i+ADJ+(SOURCESLOT-1)*0x3A+(SOURCEBOX-1)*0x6CC];
            }
		}
    
		svcSleepThread(0x400000LL);
		GSPGPU_FlushDataCache(buf, 0x10000);
		GX_SetTextureCopy(buf, addr, 0x10000, 0, 0, 0, 0, 8);
		GSPGPU_FlushDataCache(addr, 0x10000);
		svcSleepThread(0x400000LL);
	}	

    return 0;
}